//+------------------------------------------------------------------+
//|                                           MTF_    StepSto_v2.mq4 |
//|                                Copyright  2006, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//| MTF_ www.forex-tsd.com            E-mail: igorad2003@yahoo.co.uk |
//|            Thanks to Nikolay Kositsin for good reversal tecnique | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory; mtf  2006, Keris2112"
#property link "http:/finance.groups.yahoo.com/group /TrendLaboratory http:/www.forex-tsd.com"  
 
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 DeepSkyBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_level1 20
#property indicator_level2 30
#property indicator_level3 70
#property indicator_level4 80
#property indicator_levelcolor  SlateGray
//---- input parameters
extern int TimeFrame=0;
extern int     Length      = 10;    // Volty Length
extern double  Kfast       =  1;    // Sensivity Factor for Fast Line
extern double  Kslow       =  1;    // Sensivity Factor for Slow Line
extern int     MA_Mode     =  0;    // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     StepSizeMIN =  0;    // Minimum Step Size  (if need)
extern int     StepSizeMAX =  0;    // Maximum Step Size  (if need)

//---- indicator buffers   
double LineFastBuffer[];
double LineSlowBuffer[];
//double SminMin[],SmaxMin[],SminMax[],SmaxMax[],SminMid[],SmaxMid[];

//int    time[2],TRENDMIN[2],TRENDMID[2],TRENDMAX[2];
//bool   Expert=true;
//double ATR0,ATRmax=0,ATRmin=100000;

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,LineFastBuffer);
   SetIndexBuffer(1,LineSlowBuffer);

//----
   SetIndexDrawBegin(0,Length);
   SetIndexDrawBegin(1,Length);
//-- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Per_M1"; break;
      case 5 : TimeFrameStr="Per_M5"; break;
      case 15 : TimeFrameStr="Per_M15"; break;
      case 30 : TimeFrameStr="Per_M30"; break;
      case 60 : TimeFrameStr="Per_H1"; break;
      case 240 : TimeFrameStr="Per_H4"; break;
      case 1440 : TimeFrameStr="Per_D1"; break;
      case 10080 : TimeFrameStr="Per_W1"; break;
      case 43200 : TimeFrameStr="Per_MN1"; break;
      default : TimeFrameStr="Curr_TF";
   } 
   string short_name;
 
    short_name="StepSto v2[" + TimeFrameStr+ "]("+DoubleToStr(Kfast,2)+","+DoubleToStr(Kslow,2)+")";
   IndicatorShortName(short_name);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"StepSto fast("+Length+")("+DoubleToStr(Kfast,2)+","+DoubleToStr(Kslow,2)+")");
   SetIndexLabel(1,"StepSto slow("+Length+")("+DoubleToStr(Kfast,2)+","+DoubleToStr(Kslow,2)+")");

  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF 
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  

  LineFastBuffer[i]=iCustom(NULL,TimeFrame,"StepSto_v2",
         Length,  Kfast,Kslow, MA_Mode, StepSizeMIN,StepSizeMAX,0,y);
  LineSlowBuffer[i]=iCustom(NULL,TimeFrame,"StepSto_v2",
         Length,  Kfast,Kslow, MA_Mode, StepSizeMIN,StepSizeMAX,1,y);

   }  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (TimeFrame < Period()) TimeFrame = Period();
   if (TimeFrame>Period()) {
     int PerINT=TimeFrame/Period()+1;
     datetime TimeArr[]; ArrayResize(TimeArr,PerINT);
     ArrayCopySeries(TimeArr,MODE_TIME,Symbol(),Period()); 
     for(i=0;i<PerINT+1;i++) {if (TimeArr[i]>=TimeArray[0]) {
//----
 /************************************************ by Raff   
    Refresh buffers:         buffer[i] = buffer[0];
 ********************************************************/  

   LineFastBuffer[i]=LineFastBuffer[0];
   LineSlowBuffer[i]=LineSlowBuffer[0];

//----
   } } }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++


   return(0);
  }
//+------------------------------------------------------------------+